<script lang="ts" setup>
import { onMounted, onUnmounted, ref } from "vue";
import axios from "axios";
import { useRouter } from "vue-router";
import ModulesTable from "../components/tables/ModulesTable.vue";
import UploadModuleButton from "../components/buttons/UploadModuleButton.vue";

const tableData = ref([]);
const loading = ref(true);
const loadedOnce = ref(false);

let poll = true;
let timerRef = 0;
async function loadData() {
    const res = await axios.get(`${window.origin}/api/modules`);
    tableData.value = res.data;
}

async function doPolling() {
    if (!poll) return;

    loading.value = true;
    try {
        await loadData();
    } catch (error) {
        console.log(error);
    }
    loading.value = false;
    loadedOnce.value = true;

    timerRef = setTimeout(doPolling, 5000);
}

onMounted(() => {
    doPolling();
});

onUnmounted(() => {
    poll = false;
    clearTimeout(timerRef);
});

const router = useRouter();
</script>

<template>
    <UploadModuleButton class="mb-4" />
    <div class="items-left justify-center">
        <ModulesTable :tableData="tableData" :loading="!loadedOnce && loading" />
    </div>
    <Spinner v-show="loadedOnce && loading" :size="30" />
</template>
